unit connectfrm;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons;

type

  { Tconnf }

  Tconnf = class(TForm)
    connbutt: TButton;
    cancelbutt: TButton;
    authlabel: TLabel;
    puser: TEdit;
    ppass: TEdit;
    puserl: TLabel;
    phost: TEdit;
    pport: TEdit;
    ppassl: TLabel;
    vhost: TEdit;
    vport: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure authlabelClick(Sender: TObject);
    procedure cancelbuttClick(Sender: TObject);
    procedure connbuttClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  connf: Tconnf;

implementation
uses process, registry;
{ Tconnf }

procedure Tconnf.connbuttClick(Sender: TObject);
var vncproc, tunnelproc, confproc:TProcess;
var prcmdline: String;
begin
    self.Hide;
    vncproc := TProcess.create(nil);
    confproc := TProcess.create(nil);
    tunnelproc := TProcess.create(nil);
    vncproc.CommandLine := 'winvnc4 -noconsole QueryConnect=1 DisableEffects=1' +
             ' RemovePattern=1 RemoveWallpaper=1 LocalHost=1 DisableOptions=1' +
             ' AcceptPointerEvents=1 AcceptKeyEvents=1 Password= DisconnectAction=None' +
             ' DisableLocalInputs=0 QueryOnlyIfLoggedOn=0 Hosts=+0.0.0.0/255.255.255.255';
    if phost.Text<>'' then begin
       confproc.CommandLine := 'winvnc4 -connect 127.0.0.1:5678';
       prcmdline := 'proxytunnel -a 5678 --proxy='+self.phost.Text+':'+self.pport.Text;
       prcmdline := prcmdline +' --dest=' + self.vhost.Text + ':' + self.vport.Text;
       if self.puser.text<>'' then begin
          prcmdline := prcmdline + ' --proxyauth=' + self.puser.Text + ':' + self.ppass.Text;
       end;
       tunnelproc.ShowWindow := swoHIDE;
       tunnelproc.CommandLine := prcmdline;
       tunnelproc.Execute;
    end else begin
        confproc.CommandLine := 'winvnc4 -connect ' + self.vhost.Text + ':' + self.vport.Text;
    end;
    confproc.ShowWindow := swoHIDE;
    vncproc.Execute;
    sleep(800);
    confproc.Options := confproc.Options + [poWaitOnExit];
    confproc.Execute;
    confproc.Free;
    vncproc.WaitOnExit;
    vncproc.Free;
    if tunnelproc.Active then
       tunnelproc.Terminate(0);
    tunnelproc.Free;
    Application.Terminate;
end;

procedure Tconnf.cancelbuttClick(Sender: TObject);
begin
     Application.Terminate;
end;

procedure Tconnf.authlabelClick(Sender: TObject);
begin
  puser.Visible:=true;
  puserl.Visible:=true;
  ppass.Visible:=true;
  ppassl.Visible:=true;
  self.Height:=200;
end;

procedure Tconnf.FormCreate(Sender: TObject);
var reg: TRegistry;
    proxystring : String;
    prlist : TStringList;
begin
     reg := TRegistry.Create(KEY_READ);
     reg.RootKey:= HKEY_CURRENT_USER;
     if reg.OpenKeyReadOnly('Software\Microsoft\Windows\CurrentVersion\Internet Settings') then begin
        if reg.ReadInteger('ProxyEnable')<>0 then begin
           proxystring:=reg.ReadString('ProxyServer');
           prlist := TStringList.Create;
           ExtractStrings([':'],[' '], PCHAR(proxystring), prlist);
           phost.text := prlist[0];
           if prlist.Count>=2 then
              pport.text := prlist[1];
           prlist.free;
        end
     end
end;

initialization
  {$I connectfrm.lrs}

end.

